/*
	Copyright 1985, 1986, 1987, 1988, 1989, 1990, 1991 Chris Lewis
		All Rights Reserved

    See the LICENSE file for a full description of restrictions under which
    this software is provided.

    Function:		Optimizer module
 */

#include "defs.h"

int optrun = 15;
int fixedperiodwidth = 0;
int spaceopt = 0;

int specXPos, specYPos;
extern struct cattab tabN[], tabS[];
#ifdef SPACEOPT
int spcwidth, spccount, spcnom;
#endif

#ifdef	OPT
#ifndef	lint
static char SCCSid[] =
    "@(#)opt.c: 2.13 Copyright 92/10/30 02:25:40 Chris Lewis";
#endif

struct insbuf {
    char font, points, nc;
    short xpos, ypos;
};

#define	INSBUFSIZ	200
struct insbuf insbuf[INSBUFSIZ];
static struct insbuf *insptr = insbuf;
static int insypos = -1;

canoninsert(xpos, ypos, font, points, nc)
register int xpos, ypos;
register int font, points, nc; {
    DBP((D_CAT, "canoninsert: %d %d %d %d %d\n", xpos, ypos, font, points,
	nc));

    if (insypos != ypos || (insptr - insbuf >= INSBUFSIZ - 2)) {
	canonflush();
	insypos = ypos;
    }
    insptr->font = font;
    insptr->points = points;
    insptr->nc = nc;
    insptr->xpos = xpos;
    insptr++;
}

#ifdef	SORT
int xsortorder;

xsort(a, b)
register struct insbuf *a, *b; {
    int ret;
    if (a->xpos < b->xpos)
	ret = -1;
    else if (a->xpos > b->xpos)
	ret = 1;
    else
	ret = 0;
    return(xsortorder * ret);
}
#endif

canonflush() {
    register struct insbuf *ip;
    insptr--;
    DBP((D_CAT, "canonflush: start: %d chars\n", insptr - insbuf + 1));

    if (insptr < insbuf) {
	insptr = insbuf;
	return;
    }

    if (insptr->xpos < insbuf[0].xpos) {
	DBP((D_CAT, "canonflush: BACK (%d chars)\n", insptr - insbuf + 1));
#if defined(DEBUG)
	insdump(insbuf, insptr);
#endif
	for(ip = insptr;ip >= insbuf; ip--)
	    canonchar(ip->xpos, insypos, ip->font, ip->points, ip->nc);
    } else {
	DBP((D_CAT, "canonflush: FORW (%d chars)\n", insptr - insbuf + 1));
#if defined(DEBUG)
	insdump(insbuf, insptr);
#endif
	for(ip = insbuf;ip <= insptr; ip++)
	    canonchar(ip->xpos, insypos, ip->font, ip->points, ip->nc);
    }
    insptr = insbuf;
    optflush();
}

canonchar(xpos, ypos, font, points, nc)
register int xpos, ypos;
register int font, points, nc; {
    static struct insbuf lastchar;
    static short lastypos;
    static sstate = 0;
    static char sbuf[512];
    register char *p;
#ifdef	INSPECIAL
    /* Inline special directives, not supported yet */
    switch(sstate) {
	case 0:
	    if (font == symidx && nc == 34) {
		sstate = 1;
		lastchar.xpos = specXPos = xpos;
		lastchar.font = font;
		lastchar.points = points;
		lastchar.nc = nc;
		lastypos = specYPos = ypos;
		optflush();
		return;
	    }
	    break;
	case 1:
	    if (font == symidx && nc == 34) {
		if (xpos == lastchar.xpos && ypos == lastypos) {
		    sstate++;
		    sbuf[0] = '\0';
		    return;
		} else {
		    lastchar.xpos = xpos;
		    lastypos = ypos;
		    /* stay in this state */
		}
	    } else
		sstate = 0;

	    if (be->beputchar)
		(*be->beputchar)(lastchar.xpos, lastypos, lastchar.font,
		    lastchar.points, lastchar.nc, (char *) NULL);
	    break;
	case 2:
	    if (nc == 34 && font == symidx) {
		DBP((D_CAT, "Special inline sequence: %s\n", sbuf));
		dospecial(sbuf);
		sstate = 0;
		return;
	    }
	    if (strlen(sbuf) > sizeof(sbuf) - 1) {
		fprintf(stderr,
		    "%s: unterminated/too long \\(bs\\(bstr\\(bs\n",
		    progname);
		sstate = 0;
		return;
	    }
	    if (font == symidx)
		p = tabS[nc].ch_name;
	    else
		p = tabN[nc].ch_name;
	    if ((int)strlen(p) >= 2) {
		if (strcmp(p, "hy") == 0 ||
		    strcmp(p, "mi") == 0 ||
		    strcmp(p, "\\-") == 0)
		    p = "-";
		else if (strcmp(p, "ff") == 0 ||
			 strcmp(p, "fi") == 0 ||
			 strcmp(p, "fl") == 0)
		    ;
		else if (strcmp(p, "Fi") == 0)
		    p = "ffi";
		else if (strcmp(p, "Fl") == 0)
		    p = "ffl";
		else
		    p = " ";
	    }
	    strcat(sbuf, p);
	    return;
    }
#endif
    optinsert(xpos, ypos, font, points, nc);
}

int optxpos, optypos;
int optfont, optpoints, optnc, origxpos, optsymset, optcnt=0;
char optbuffer[OPTSIZ];
short optloc[OPTSIZ];
short *optloci;
char *optp = optbuffer;

optflush() {

    if (!optimize)
	return;
#if defined(DEBUG) && defined(SPACEOPT)
    if ((debug&D_CHAR) && spcwidth) {
	DBP((D_CHAR, "LOPT: x,y,sw,sc,nl,s: %d,%d,%d,%d,%d\n",
	    origxpos, optypos, spcwidth, spccount, spcnom, optbuffer));
    }
#endif

    if (optbuffer[0] && be->beputchar)
	(*be->beputchar)(origxpos, optypos, optfont, optpoints, optnc,
	    optbuffer);
    optbuffer[0] = '\0';
    optp = optbuffer;
    optloci = optloc;
    optcnt = 0;
#ifdef SPACEOPT
    spccount = spcwidth = 0;
#endif
}

optinsert(xpos, ypos, font, points, nc)
int font, points, nc;
int xpos, ypos; {
    struct troff2befont *bp;
    static char *wp;
    extern struct cattab tabN[], tabS[];
    struct cattab *ct;
    register char *from;
    int cantcache;
    static int ditind = 0, psind = 0;

    if (!optimize) {
	if (be->beputchar)
	    (*be->beputchar)(xpos, ypos, font, points, nc, (char *) NULL);
	return;
    }

    if (!ditind)
	if (strcmp(be->bename, "dt") == 0)
	    ditind = 1;
	else
	    ditind = -1;

    DBP((D_CHAR, "OLD: x,y,f,p,c = %d,%d,%d,%d,%d\n",
	optxpos, optypos, optfont, optpoints, optnc));
    DBP((D_CHAR, "NEW: x,y,f,p,c = %d,%d,%d,%d,%d\n",
	xpos, ypos, font, points, nc));

    /* the 10 is to ensure that there's enough room for moderately
       long multiple-character sequences */

    if (ypos != optypos || optfont != font || optpoints != points ||
	wp != xlatetable[font]->widthtable || optcnt >= optrun ||
	optxpos > xpos || optp > optbuffer + OPTSIZ - 10)
	optflush();

    wp = xlatetable[font]->widthtable;

    if (font == symidx) {
	bp = &be->besymfont[nc];
	ct = &tabS[nc];
    } else {
	bp = &be->bestdfont[nc];
	ct = &tabN[nc];
    }

    cantcache = !wp || (int) wp == 1
			     || bp->t2b_xc || bp->t2b_yc || bp->t2b_scale
			     || bp->t2b_font == D
			     /* period widths are screwed in some Postscript
				interpreters */
			     || (!fixedperiodwidth && (font != symidx && nc == 35))
			;

    if (cantcache ||
	(optbuffer[0] ? (bp->t2b_font != optsymset) :
	    (font == symidx ? bp->t2b_font != S : bp->t2b_font != N)))
	optflush();

    DBP((D_CAT, "opt: font: %d/%d xpos: %d/%d, optloc: %d\n",
	optfont, font, optxpos, xpos, optloci-optloc));

#ifdef SPACEOPT
    if (!psind)
	if (strcmp(be->bename, "ps") == 0)
	    psind = 1;
	else
	    psind = -1;
    if (spaceopt && psind == 1 && optbuffer[0] && optxpos < xpos &&
	optcnt < optrun - 5 && bp->t2b_font == N) {
	/* possible blank/space optimization */

	if (!spcwidth) {	/* first space we've seen this line */
	    spcnom = (wp[0] * points + 3) / 6;	/* *nominal* space width.  CAT
						   doesn't read it - hardcoded.
						   GRRRR. */
	    spcwidth = xpos - optxpos;
	    spccount = 1;
	    *optloci = optxpos;
	    optxpos = xpos;
	    *optp++ = ' ';
	    *optp = '\0';
	} else if ((xpos - optxpos) % spcwidth == 0) {
	    int sw;
	    sw = (xpos - optxpos) / spcwidth;
	    if (sw < 0) {
		fprintf(stderr, "%s: negative space count!  Get help! (disable -gl)\n");
		exit(1);
	    }
	    if (sw + optcnt < optrun - 5) {
		while(sw--) {
		    optcnt++;
		    spccount++;
		    *optloci++ = optxpos;
		    *optp++ = ' ';
		}
		*optp = '\0';
		optxpos = xpos;
	    }
	}
    }
#endif

    if (optxpos != xpos)
	optflush();

    if (!optbuffer[0]) {
	optypos = ypos;
	optxpos = xpos;
	origxpos = xpos;
	optfont = font;
	optsymset = bp->t2b_font;
	optnc = nc;
	optpoints = points;
    }

    if (cantcache) {
	if (be->beputchar)
	    (*be->beputchar)(xpos, ypos, font, points, nc, (char *) NULL);
	return;
    }

    *optloci++ = optxpos;
    optxpos += ((wp[ct->ch_wididx]&0x3f) * points + 3) / 6;
    DBP((D_CAT, "optxpos: %d->%d, optlocioff: %d\n", *(optloci-1), optxpos,
	optloci-optloc));

    from = bp->t2b_charseq;
    if (ditind == 1) {
	if (*from == '\\') {
	    *optp++ = '\\';
	    optcnt++;
	} else if (*(from+1)) {
	    *optp++ = '\\';
	    *optp++ = '(';
	    *optp++ = *from++;
	    optcnt += 3;
	}
	*optp++ = *from++;
	optcnt++;
	
    } else
	for (; *from;) {
	    optcnt++;
	    *optp++ = *from++;
	}
    *optp = '\0';
}
#endif

#if defined(DEBUG)
insdump(b, p)
register struct insbuf *b, *p; {
    if (!(debug&D_VERB))
	return;
    DBP((D_VERB, "insdump:\n"));
    for(; b <= p; b++)
	DBP((D_VERB, "%d %d\n", b->xpos, b->nc));
}
#endif
