/*	Copyright 1992 Chris Lewis
		All Rights Reserved

    See the LICENSE file for a full description of restrictions under which
    this software is provided.

    Function: PK/SFP font scaling.  Much hackery.  Results so-so.
 */

#include "defs.h"

#ifdef	PK

#ifndef lint
static char SCCSid[] = "@(#)pkscale.c 1.4 Copyright 92/12/04 23:12:13 Chris Lewis";
#endif

#include "pk.h"

long
scalenum(sf, num)
double sf;
long num; {
    if (num < 0)
	return((long) (sf * num - .5));
    else
	return((long) (sf * num + .5));
}

static short *sl = (short *) NULL;
static sln = 0;

struct pkp *
pkscale(pkp, target)
struct pkp *pkp;
int target; {
    struct pkp *npkp;
    register int i,j;
    register struct pkc *pc, *npc;
    extern struct ras *pkrast();
    double sf;

    if (!target || target == pkp->pkp_npts)
	return(pkp);

    if (sl) {
	free(sl);
	sl = (short *) NULL;
	sln = 0;
    }
    
    sf = (double) target / pkp->pkp_npts;

    npkp = (struct pkp *) mustmalloc(sizeof(struct pkp),
	"New PK header for scale");
    *npkp = *pkp;
    npkp->pkp_list = (struct pkc **)
	mustmalloc(sizeof(struct pkc *) * pkp->pkp_num,
	"New PK sort list for scale");

    npkp->pkp_chars = (struct pkc *) NULL;
    npkp->pkp_last = (struct pkc *) NULL;

    npkp->pkp_ds = scalenum(sf, npkp->pkp_ds);
    npkp->pkp_npts = scalenum(sf, npkp->pkp_npts);
    npkp->pkp_bmax = scalenum(sf, npkp->pkp_bmax);
    npkp->pkp_dmax = scalenum(sf, npkp->pkp_dmax);
    npkp->pkp_wmax = scalenum(sf, npkp->pkp_wmax);
    npkp->pkp_xomax = scalenum(sf, npkp->pkp_xomax);
    npkp->pkp_kh = scalenum(sf, npkp->pkp_kh);
    npkp->pkp_kl = scalenum(sf, npkp->pkp_kl);

    DBP((D_FONT,"To scale %d characters\n", pkp->pkp_num));
    for (i = 0; i < pkp->pkp_num; i++) {
	register struct ras *r;

	pc = pkp->pkp_list[i];

	DBP((D_FONT,"Scale char %ld (%c) to %d (%f)\n", pc->pkc_char,
	    pc->pkc_char, target, sf));

	/* create new char descriptor, initialized to old */
	npc = (struct pkc *) mustmalloc(sizeof(struct pkc),
	    "New PK character descriptor");
	*npc = *pc;
	if (!npkp->pkp_chars)
	    npkp->pkp_chars = npc;
	else
	    npkp->pkp_list[i-1]->pkc_next = npc;

	npkp->pkp_last = npc;
	npkp->pkp_list[i] = npc;


	/* get a raster to play with */
	pc->pkc_sfpr = pkrast(pc);
	if (pc->pkc_pkr)
	    free((char *) pc->pkc_pkr);
	pc->pkc_pkr = (int8 *) NULL;

	npc->pkc_sfpr = r = (struct ras *) mustmalloc(sizeof(struct ras),
	    "SFP raster header for scale");
	
	npc->pkc_pkr = (int8 *) NULL;
	npc->pkc_height = scalenum(sf, npc->pkc_height)+1;
	npc->pkc_width = scalenum(sf, npc->pkc_width)+1;
	npc->pkc_dx = scalenum(sf, npc->pkc_dx);
	npc->pkc_dy = scalenum(sf, npc->pkc_dy);
	npc->pkc_x_off = scalenum(sf, npc->pkc_x_off);
	npc->pkc_y_off = scalenum(sf, npc->pkc_y_off);

	r->ras_height = npc->pkc_height;
	r->ras_width = npc->pkc_width;
	r->ras_bline = (npc->pkc_width + 7) / 8;
	r->ras_bytes = r->ras_height * r->ras_bline;
	r->ras_raster = (int8 *) mustmalloc((int) r->ras_bytes,
	    "SFP raster for scale");
	
	rastscale(r, pc->pkc_sfpr, sf);

    }
    pk_destroy(pkp);
    return(npkp);
}

#define seton(x,y,r) r->ras_raster[y * r->ras_bline + (x >> 3)] |= (0x80 >> (x&7))
#define biton(x,y,r) r->ras_raster[y * r->ras_bline + (x >> 3)] & (0x80 >> (x&7))

#define BLOT
#ifdef BLOT
short blot1[] = {-1, 0,
		 0, 1,
		 1, 0,
		 0, -1,
		 0, 0};
short blot2[] = {-2,0,
		-1,0,
		-1,1,
		0,1,
		0,2,
		1,1,
		1,0,
		2,0,
		1,-1,
		0,-1,
		0,-2,
		-1,-1,
		0,0};
short *blotlist[] = {blot1, blot2, blot2, blot2, blot2, blot2};
#endif

rastscale(to, from, scale)
register struct ras *to, *from;
double scale; {
    register int x, y;
    register int ct = scale;
    register struct ras *nr;

    /* optimization to avoid floating point */
    x = max(from->ras_height, from->ras_width) + 10;
    if (x > sln) {
	register short *p;
	if (sl)
	    free(sl);
	p = sl = (short *)mustmalloc(sizeof(short) * x,
	    "SFP raster scale array");
	sln = x;
	for (x = 0, p = sl; x < sln; x++)
	    *p++ = scale * x + .5;
    }

    DBP((D_FONT, "rast %d:%d (%d) -> %d:%d (%d) (%f)\n",
	from->ras_width, from->ras_height, from->ras_bytes,
	to->ras_width, to->ras_height, to->ras_bytes, scale));

    clrarray(to->ras_raster, to->ras_bytes);

    /* dumb scaling algorithm. */
    for (y = 0; y < from->ras_height; y++)
	for (x = 0; x < from->ras_width; x++) {
	    if (biton(x, y, from)) {
		register int sy = sl[y], sx = sl[x];
		seton(sx, sy, to);

		/* if scale > 1, we centre a ct*ct box on it */
#ifdef BLOT
		if (ct) {
		    register int tsx, tsy;
		    register short *p = blotlist[ct-1];

		    while(*p || *(p+1)) {
			tsx = sx + *p++;
			tsy = sy + *p++;
			if (tsx < 0 || tsx >= to->ras_width ||
			    tsy < 0 || tsy >= to->ras_height)
			    continue;
			seton(tsx, tsy, to);
		    }
		}
#else
		if (ct) {
		    register int tsy, tsx, limx, limy;
		    limy = min(sy + ct + 1, to->ras_height);
		    for (tsy = max(sy-ct,0) ; tsy < limy; tsy++) {
			limx = min(sx + ct + 1, to->ras_width);
			for (tsx = max(sx-ct, 0); tsx < limx; tsx++) {
			}
		    }
		}
#endif
	    }
	}

}

#endif
